""" (scratch space)
4 0 x              x          x      0        0     0     0        0
3 1 x              x    x     x      x    1   x   1 x     x     1  x
2 2          x          x       x      2  x     2 x   2    2    x   2
1 3        x x            x     x      x    3   x     x3   x  3     x
0 4        x     x        x   x          4  x  4       x      x  4
1 5              x   x        x x        x 5   x     5      5    x
2 6     x            x      x   x     6    x     6   x  6   x6    6
3 7     x      x            x x       x 7    7   x 7    x7   x 7  x
4              x              x         x    x     x     x     x

0   0     0         0   0          0        0      0          0
1   x  1  x    1    x  1x    1     x     1  x   1  x     1    x1
2    2 x       x       x 2   x   2   2   x    2 x    2   x   2 x
3    x       3  3        x  3   3x   x        x3    3x     3 x 
4           4x  x  4       4x   x 4       4    x 4  x      x4   
5        5  x      x 5     x  5   x     5 x      x5     5   x   5
6     6  x    6   6  x6       x6      6 x  6      x    6x       x6 
7  7  x 7  7  x  7x   x   7    x    7 x7   x 7        7x  7      x7
_  x    x  x     x        x         x  x     x        x   x       x

"""

# Rocks:  Opening easy part (8-35)
rocks = [
(8,0),(12,6),(16,3),(18,2),(20,7),(22,4),(24,0),(26,5),(28,1),(30,3),(32,6),(34,0),(34,4),(34,7),(35,2),(35,5),
]

# Rocks:  Swangin Part A (40-72)
sss = "06274153704261705236702563714602"
for i in xrange(len(sss)):
	rocks.append((40+i, int(sss[i])))

# Rocks:  Swangin Part B (72-104?)
sss = "7026175074361376405610274315632407267514607231450327651734201567"
for i in xrange(len(sss)):
	rocks.append((72.0+i/2.0, int(sss[i])))

""" [SCRATCH SPACE FOR COCKS]
0    0    0   0      0   0      0   0       0   0      0     0
   1  1     1     1   1   1  1   1   1   1   1     1    1   1
  2      2     2    2      2      2     2     2   2   2    2
    3   3  3     3     3      3    3   3   3   3    3    3     3
 4     4     4  4  4    4   4  4      4   4      4   4    4   4
^                               ^                               ^
 0   0  0  0     0   0  0     0    0   0    0  0    0  0   0
1         1   1     1      1   1     1    1     1    1    1  1
   2   2     2  2        2  2     2     2    2    2     2     2
    3    3     3   3   3     3   3  3 3    3     3    3     3
  4   4     4     4   4   4     4        4    4    4     4     4
^                               ^                               ^
0    0  0    0  0    0     0     0  0    0   0    0   0     
  1 1       1  1   1   1      1      1  1   1      1   1   1
   2   2      2       2     2  2  2       2     2   2     2
      3   3      3       3   3     3   3   3   3        3
 4       4 4      4 4   4 4     4     4       4  4   4   4
^                               ^                               ^
aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
"""

# Cocks:  Part A (112-204)
cocks = []
sss  = "04213014320314024314201340124134" # 112-127.5
sss += "01230143214301230421342013421043" # 128-143.5
sss += "10423042031042132043104302412301" # 144-159.5
sss += "43203130241302401324013024103124" # 160-175.5
sss += "04121032043410210341402143402312" # 176-191.5
sss += "4023014310231043"                 # 192-...
for i in xrange(len(sss)):
	if sss[i] == "_": continue
	cocks.append((112.0+i/2.0, int(sss[i])))

c2n = dict([(0,-3.5),(1,-2.5),(2,-1.5),(3,-0.5),(4,0.5),(5,1.5),(6,2.5),(7,3.5)])
yc = [-122,-87,-52,-17,17,52,87,122]

# Eels:  FUCK (208-228)
eels = [(208,0),(212,1),(216,0),(220,1)]

""" (Scratch space for final rocks)
0|0         0       0                 0                         0
1|x       1 x       x 1       1 E     x   1           1         x 
2|        x           x       x E         x     2     x         E
3|  3           3           3   E   3       3   x           3   E
4|  x           x 4         x   E 4 x       x       4     4 x   E
5|            5   x             E x               5 x     x   5 E
6|      6     x           6     E       6         x           x E
7|    7 x               7 x     7       x     7         7       E
-|    x                 x       x #           x         x         #
                ^               ^ #             ^               ^ #
  1234567812345678123456781234567812345678123456781234567812345678 (i drew the eels on the wrong lines, whoops)

0|   0        0 0     0                0       0         0      E0
1|1  x   1    x x  1  x        1E      x       x 1     1 x   1  Ex
2|x 2    x 2   2   x      2 2  xE2         2     x 2   x     x  E
3|  x 3   3x   x         3x x   Ex 3    3  x       x 3     3    3
4|    x 4 x          4   x 4    4  x 4  x   4        x    4x  4 x
5| 5    x        5  5x     x    x 5  x   5  x   5         x 5 x E
6| x        6    x6 x         6 E x   6  x    6 x 6   6     x  6E
7|     7    x7    x    77    7x E   7 x   7  7x   x 7 x 7      xE
-|     x     x         xx    x  E   x     x  x      x   x
                ^               ^               ^               ^
  1234567812345678123456781234567812345678123456781234567812345678 (i drew the eels on the wrong lines, whoops)

0|     0     0     0  0
1|  1  x     x  1  x  x
2|  x     2     x     2  2
3|     3  x     3  3  x  x
4|  4  x     4  x  x     4
5|  x     5  x     5  5  x
6|     6  x     5  x  x  6
7|  7  x  7  6  x  7     x
-|  x     x  x     x


"""

# Rocks: Finale, Part 1 (224-255)
sss = "03761053401763174306137254174350"
for i in xrange(len(sss)):
	rocks.append((224+i, int(sss[i])))
eels.append((240, 0))
eels.append((256, 1))

# Rocks: Finale, Part 2 (256-287.5)
sss = "1520374132670205615407732427614253746035724760516273617043514630"
for i in xrange(len(sss)):
	rocks.append((256+i/2.0, int(sss[i])))
eels.append((272, 0))
eels.append((288, 1))

# Rocks: Finale, Part 3 (288-302)
ass = ["14", "036", "257", "046", "135", "0357", "025", "246"]
for i in xrange(len(ass)):
	for c in ass[i]:
		rocks.append((288+2*i, int(c)))

eels.append((304, 0))
eels.append((306, 1))

# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

# Determine layers for rocks
NUM_ROCK_LAYERS = 3
rock_layers = []
for i in xrange(NUM_ROCK_LAYERS):
	rock_layers.append([[],[],[],[],[],[],[],[]])

for t,p in rocks:
	for i in xrange(len(rock_layers)):
		f = rock_layers[i][p]
		if not (len(f) > 0 and t < f[-1] + 6):
			f.append(t)
			break
	else:
		print "YOLO", t, p

# Determine layers for cocks
NUM_COCK_LAYERS = 4
cock_layers = []
for i in xrange(NUM_COCK_LAYERS):
	cock_layers.append([[],[],[],[],[]])

for t,p in cocks:
	for i in xrange(len(cock_layers)):
		f = cock_layers[i][p]
		if not (len(f) > 0 and t < f[-1] + 4.5):
			f.append(t)
			break
	else:
		print "HOMO SWAG", t, p

# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

# Rock XML tags/animation
ROCK_1 = """		<!-- Rock %.1f%s -->
		<Layer
			File="rock2.png"
			InitCommand="y,%d;x,900"
			TimerMessageCommand="%%function(self)
				local b = GAMESTATE:GetSongBeat();
"""
ROCK_2 = """				if b > %f and b < %f then
					self:x(800-(b-%f)/5.5*1000)
				end
"""
ROCK_3 = """			end"
		/>

"""

# Rock detection tests
OUCH_1 = """			if Safe == 0 and (RDPos == %d or RDPos == %d) then -- Rock %.1f%s
				if 0==1
"""
OUCH_2 = """				or (b >= %f+5.5*0.668 and b <= %f+5.5*0.824)
"""
OUCH_3 = """				then
					Safe = 1
					SafeBeat = b + 4.0
					Lives = Lives - 1
					MESSAGEMAN:Broadcast('LifeUpdate');
					-- SCREENMAN:SystemMessage('%.1f%s ' .. b)
					return
				end
			end
"""

# Cock XML tags/animation
COCK_1 = """
		<!-- Cock %d%s -->
		<Layer
			File="shittiest.png"
			InitCommand="hidden,1"
			TimerMessageCommand="%%function(self)
				local b = GAMESTATE:GetSongBeat();
				local hide = 1;
"""
COCK_2 = """				if b >= %f and b <= %f then
					local d = L*(%f-b)/4.0
					local cx = 2 * math.atan((%.1f-RDPos2)*W/d) / Tx * FW
					local cy = 2 * math.atan(-0.5*H/d) / Ty * FH
					local dx = 2 * math.atan((%.1f-RDPos2)*W/d) / Tx * FW
					local dy = 2 * math.atan(0.5*H/d) / Ty * FH

					hide = 0
					self:x((cx+dx)/2.0)
					self:y((cy+dy)/2.0)
					self:zoomx(math.abs(dx-cx)/W)
					self:zoomy(math.abs(dy-cy)/W)
					if b >= %f+3.5 then
						self:glow(0.05,0,0,0.5)
					else
						self:glow(0,0,0,0)
					end
				end
"""
COCK_3 = """				self:hidden(hide)
			end"
		/>
"""

# Cock detection tests
OWNED_1 = """			if Safe == 0 and RDPos2 == %d then -- Cock %d%s
				if 0==1
"""
OWNED_2 = """				or (b >= %f+3.8 and b <= %f+4.0)
"""
OWNED_3 = """				then
					Safe = 1
					SafeBeat = b + 4.0
					Lives = Lives - 1
					MESSAGEMAN:Broadcast('LifeUpdate');
					return
				end
			end
"""

# Eel XML tags/animation
EEL_BOT = """		<Layer
			File="bad_bitch.png"
			InitCommand="y,430;x,900;zoomy,-1"
			TimerMessageCommand="%%function(self)
				local b = GAMESTATE:GetSongBeat();
				if b > %f and b < %f+6 then
					self:x(800-(b-%f)/5.5*1000)
					if b < %f+5.5*0.648 then
						self:y(430)
					elseif b < %f+5.5*0.668 then
						self:y(430-290*(b-(%f+5.5*0.648))/(5.5*0.028))
					else
						self:y(430-290)
					end
				end
			end"
		/>
		<Layer
			File="hole.png"
			InitCommand="y,190;x,900;zoomy,-1"
			TimerMessageCommand="%%function(self)
				local b = GAMESTATE:GetSongBeat();
				if b > %f and b < %f+6 then
					self:x(800-(b-%f)/5.5*1000)
				end
			end"
		/>
"""
EEL_TOP = """		<Layer
			File="bad_bitch.png"
			InitCommand="y,-430;x,900"
			TimerMessageCommand="%%function(self)
				local b = GAMESTATE:GetSongBeat();
				if b > %f and b < %f+6 then
					self:x(800-(b-%f)/5.5*1000)
					if b < %f+5.5*0.648 then
						self:y(-430)
					elseif b < %f+5.5*0.668 then
						self:y(-430+290*(b-(%f+5.5*0.648))/(5.5*0.028))
					else
						self:y(-430+290)
					end
				end
			end"
		/>
		<Layer
			File="hole.png"
			InitCommand="y,-190;x,900"
			TimerMessageCommand="%%function(self)
				local b = GAMESTATE:GetSongBeat();
				if b > %f and b < %f+6 then
					self:x(800-(b-%f)/5.5*1000)
				end
			end"
		/>
"""

# Eel detection tests
BONER_0 = """			if b >= %f+5.5*0.668 and b <= %f+5.5*0.824 and Safe == 0 and RDPos ~= %d then
				Safe = 1
				SafeBeat = b + 4.0
				Lives = Lives - 1
				MESSAGEMAN:Broadcast('LifeUpdate');
				return
			end
"""
#no
BONER_1 = """			if Safe == 0 and (RDPos ~= %d) then -- Eel %s
				if 0==1
"""
BONER_2 = """				or (b >= %f+5.5*0.668 and b <= %f+5.5*0.824)
"""
BONER_3 = """				then
					Safe = 1
					SafeBeat = b + 4.0
					Lives = Lives - 1
					MESSAGEMAN:Broadcast('LifeUpdate');
					return
				end
			end
"""


# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

# Rock XML tags/animation
rock_text = "\r\n"
for k in xrange(len(rock_layers)):
	layer = rock_layers[k]
	for i in xrange(len(layer)):
		if len(layer[i]) > 0:
			rock_text += ROCK_1 % (c2n[i], chr(ord('A')+k), yc[i])
			for j in layer[i]:
				rock_text += ROCK_2 % (j, j+6, j)
			rock_text += ROCK_3

# Rock detection tests
ouch_text = "\r\n"
for k in xrange(len(rock_layers)):
	layer = rock_layers[k]
	for i in xrange(len(layer)):
		if len(layer[i]) > 0:
			ouch_text += OUCH_1 % (i-4, i-3, c2n[i], chr(ord('A')+k))
			for j in layer[i]:
				ouch_text += OUCH_2 % (j, j)
			ouch_text += OUCH_3 % (c2n[i], chr(ord('A')+k))

# Cock XML tags/generation
cock_text = "\r\n"
for k in xrange(len(cock_layers)):
	layer = cock_layers[k]
	for i in xrange(len(layer)):
		if len(layer[i]) > 0:
			cock_text += COCK_1 % (i, chr(ord('A')+k))
			for j in layer[i]:
				cock_text += COCK_2 % (j, j+4.1, j+4, i-2.5, i-1.5, j)
			cock_text += COCK_3

# Cock detection tests
owned_text = "\r\n"
for k in xrange(len(cock_layers)):
	layer = cock_layers[k]
	for i in xrange(len(layer)):
		if len(layer[i]) > 0:
			owned_text += OWNED_1 % (i-2, i-2, chr(ord('A')+k))
			for j in layer[i]:
				owned_text += OWNED_2 % (j, j)
			owned_text += OWNED_3

# Eel XML tags/animation
eel_text = "\r\n"
for a,b in eels:
	if b == 0:
		eel_text += EEL_BOT % (a,a,a,a,a,a,a,a,a)
	else:
		eel_text += EEL_TOP % (a,a,a,a,a,a,a,a,a)

# Eel detection tests
boner_text = "\r\n"
for a,b in eels:
	if b == 0:
		boner_text += BONER_0 % (a, a, -4)
	else:
		boner_text += BONER_0 % (a, a, 4)

# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

xml = open("..\default-base.xml", "rb").read()

def insert(s, tag, dump):
	i = s.find(tag)
	if i == -1:
		print "Tag %s doesn't exist, dumbass" % tag
		exit(0)
	i += len(tag)
	return s[:i] + dump + s[i:]

xml = insert(xml, "<!--[ROCKS]-->", rock_text)
xml = insert(xml, "--[OUCH]--", ouch_text)
xml = insert(xml, "<!--[COCKS]-->", cock_text)
xml = insert(xml, "--[OWNED]--", owned_text)
xml = insert(xml, "<!--[EELS]-->", eel_text)
xml = insert(xml, "--[BONER]--", boner_text)

open("..\default.xml", "wb").write(xml)